#include "Classi.hpp"

//Funzioni della classe Proiezione

Proiezione :: Proiezione ( Orario i , Orario f ) {
    assert( i < f );
    inizio = i;
    fine = f;
}

void Proiezione :: CambiaOrario ( Orario i , Orario f ) {
    assert( i < f );
    inizio = i;
    fine = f;
}

unsigned Proiezione :: NumeroPostiPrenotati () const {
    unsigned num = 0;
    for(unsigned i = 0; i < prenot.size(); i++) {
        num += prenot[i]->NumeroPostiPrenotati();
    }
    return num;
}

//Funzioni della classe GestioneCinema

GestioneCinema :: GestioneCinema () {
    
}

void GestioneCinema :: InserisciProiezione ( Proiezione *p ) {
    //Verifico che la prenotazione non sia gi stata effettuata
    for(unsigned i= 0; i < film.size(); i++) {
        assert(film[i] != p);
    }
    //Verifico che la sala non sia occupata a in quell'orario
    for(unsigned i= 0; i < film.size(); i++) {
        if(film[i]->SalaProiezione() == p->SalaProiezione()) {
            assert(film[i]->Fine() <= p->Inizio() || p->Fine() <= film[i]->Inizio());
        }
    }
    //Verifico che non vi siano presenti prenotazioni
    assert(!(p->NumeroPrenotazioni()));
    film.push_back(p);
}

void GestioneCinema :: RimuoviProiezione ( Proiezione *p ) {
    for(unsigned i= 0; i < film.size(); i++) {
        if (film[i] == p) {
            film.erase(film.begin() + i);
        }
    }
}

bool GestioneCinema :: InserisciPrenotazione ( Prenotazione *pre , Proiezione *pro) {
    //Verifico l'esistenza della proiezione
    bool esiste = false,
    for(unsigned i = 0; i < film.size(); i++) {
        if( film[i] == pro )
            esiste = true;
    }
    if(!esiste)
        return false;
    //Verifico la disponibilit di posti
    if( pre->NumeroPostiPrenotati() + pro->NumeroPostiPrenotati() <= pro->PostiInSala()) ) 
        return false;
    //Aggiungo la prenotazione
    pro->AggiungiPrenotazione(pre);
    return true;
}




