#ifndef CLASSI_HPP
#define CLASSI_HPP

class Orario {
    private:
        unsigned ora;
        unsigned minuto;
    public:
        Orario ( unsigned o = 0, unsigned m = 0) { if(o < 24 && m < 60) { ora = o; minuto = m; } else { ora = 0; minuto = 0; } }
        unsigned Ora () const { return ora; }
        unsigned Minuto () const { return minuto; }
        void Ora ( unsigned o ) { if(o < 24) { ora = o; } }
        void Minuto ( unsigned m ) { if(m < 60) { minuto = m; } }
};

class Film {
    private:
        const string TITOLO;
        const unsigned DURATA;  
    public:
        Film ( string t, unsigned d ) : TITOLO(t), DURATA(d) {}
        string Titolo () const { return TITOLO; }
        unsigned Durata () const { return DURATA; }
};

class Sala {
    private:
        const string NOME;
        const unsigned POSTI;
    public:
        Sala ( string n, unsigned p ) : NOME(n), POSTI(p) {}
        string NomeSala () const { return NOME; }
        unsigned NumeroPosti () const { return POSTI; }
};

class Prenotazione {
    private:
        const string NOME_PRENOTANTE;
        const unsigned NUMERO_POSTI;
    public:
        Prenotazione ( string n, unsigned num ) : NOME_PRENOTANTE(n), NUMERO_POSTI(num) {}
        string NomePrenotazione () const { return NOME_PRENOTANTE; }
        unsigned NumeroPostiPrenotati () const { return NUMERO_POSTI; }
};

class Proiezione {
    private:
        Orario  inizio,
                fine;
        Sala *s;
        Film *f;
        vector<Prenotazioni*> prenot;
    public:
        Proiezione ( Orario , Orario );
        Orario Inizio () const { return inizio; }
        Orario Fine () const { return fine; }
        void CambiaOrario ( Orario , Orario );
        string SalaProiezione () const { return s->NomeSala(); }
        unsigned PostiInSala () const { return s->NumeroPosti(); }
        unsigned NumeroPrenotazioni () const { return prenot.lenght(); }
        unsigned NumeroPostiPrenotati () const;
        void AggiungiPrenotazione ( Prenotazione *p ) { prenot.push_back(p); }
};

class GestioneCinema {
    private:
        vector<Proiezione*> film;
    public:
        GestioneCinema ();
        void InserisciProiezione ( Proiezione * );
        void RimuoviProiezione ( Proiezione * );
        bool InserisciPrenotazione ( Prenotazione * , Proiezione * );
        void CambiaOrario ( Proiezione * , Orario , Orario );
        void CambiaSala ( Proiezione * , Sala * );
        
};



#endif
