//Classe per la gestione delle date in C++
#include <ctime>


class Date {
    private:
        //Variabile che contiene il numero di secondi
        //trascorsi dal 1 gennaio 1970
        unsigned giorno;
        unsigned mese;
        unsigned anno;
        
        unsigned secondi;
        
        //Costanti moltiplicativi
        const unsigned SECONDI_GIORNO;
        const unsigned SESSAGGESIMALE;
        
        //Funzioni di servizio
        void CheckDate ();
        unsigned Days ();
    public:
        //Costruttori
        Date ();                    //Costruisce la data 1 gennaio 1970
        Date ( unsigned , unsigned , unsigned );   //Costruisce una data a partire dai valori numerici
        //Metodi GET
        unsigned GetDay () { return giorno; }
        unsigned GetMonth () { return mese; }
        unsigned GetYear () { return anno; }
        unsigned GetSec () { return secondi%SESSAGGESIMALE; }
        unsigned GetMin () { return (secondi%(SESSAGGESIMALE*SESSAGGESIMALE))/SESSAGGESIMALE; }
        unsigned GetHour () { return (secondi%(SESSAGGESIMALE*SESSAGGESIMALE*24))/(SESSAGGESIMALE*SESSAGGESIMALE); }
        
        //Metodi di manipolazione
        void NextDate ();
        void PreviousDate ();
        void SommaSecondi ( int );
//        unsigned dateDistance ( Date );    //Ritorna i giorni intercorsi tra 2 date
        
        //Ridefinizione degli operatori stream
		friend istream& operator >> ( istream &, Date & );
		friend ostream& operator << ( ostream &, Date );
};

Date :: Date () : SECONDI_GIORNO(86400), SESSAGGESIMALE(60) { 
    //Costruisco la data di oggi
    unsigned tmp, minuti, ore;
    tm *t;
    time_t temp;
    temp = time(NULL);
    t = localtime(&temp);
    
    giorno = t->tm_mday;
    mese = t->tm_mon+1;
    anno = 1900 + t->tm_year;
    secondi = t->tm_hour*SESSAGGESIMALE*SESSAGGESIMALE + t->tm_min*SESSAGGESIMALE + t->tm_sec;
}

Date :: Date ( unsigned g, unsigned m, unsigned a )  : SECONDI_GIORNO(86400), SESSAGGESIMALE(60) {
    giorno = g;
    mese = m;
    anno = a;
    secondi = 0;
    CheckDate();
}


void Date :: CheckDate () {
    if(!(anno > 0 && mese > 0 && giorno > 0 && giorno <= Days()))
    {
        giorno = 1;
        mese = 1;
        anno = 1970;
        //cerr<<"Data inserita non valida!"<<endl;
    }        
}

unsigned Date :: Days () {
    switch(mese) {
        //Mesi di 30 giorni
        case 4:
        case 6:
        case 9:
        case 11:
            return 30;
            break;
        //Febbraio
        case 2:
            //Faccio il controllo della bisestilit dell'anno
            if(anno % 4 == 0) {
                if(anno % 100 == 0) {
                    if(anno % 400 == 0) 
                        return 29;
                    else
                        return 28;
                }
                else
                    return 29;
            }
            else
                return 28;
            break;
        //Mesi di 31 giorni
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            return 31;
            break;
        //Qualsiasi numero che non corrisponda ad un mese
        default:
            return 0;
            break;
    }
}

void Date :: NextDate () {
    if(giorno < Days())
        giorno++;
    else {
        if(mese < 12) {
            giorno = 1;
            mese++;
        }
        else {
            giorno = 1;
            mese = 1;
            anno++;
        }
    }
}

void Date :: PreviousDate () {
    if(giorno > 1)
        giorno--;
    else {
        if(mese > 1) {
            mese--;
            giorno = Days();
        }
        else {
            anno--;
            mese = 12;
            giorno = 31;
        }
    }
}

void Date :: SommaSecondi ( int s ) {
    if( s > 0 ) {
        unsigned sommaGiorni = s/SECONDI_GIORNO;
        for(unsigned i = 0; i < sommaGiorni; i++)
            NextDate();
        
        secondi += s%SECONDI_GIORNO;
    }
    else {
        unsigned sommaGiorni = (-s)/SECONDI_GIORNO;
        for(unsigned i = 0; i < sommaGiorni; i++)
            PreviousDate();
        
        secondi -= (-s)%SECONDI_GIORNO;
    }
}

istream& operator >> ( istream &in , Date &st ) {
	//char aux[MAXDIM];
//	fflush(stdin);
//	gets (aux);
//	delete [] st.str;
//	st.str = new char[strlen(aux)+1];
//	strcpy (st.str,aux);
}
	
ostream& operator << ( ostream &out ,  Date d ) {
    //Scrivo la data
    out << d.giorno << "/" << d.mese << "/" << d.anno;
    //Scrivo l'ora
    unsigned tmp = d.secondi%(60*60);
    unsigned ora = d.secondi/(60*60);
    unsigned minuti = tmp/60;
    unsigned sec = tmp%60;
    
    out << " - " << ora << ":" << minuti << ":" << sec;
}
