#define MAXDIM 255

//Classe per la gestione dinamica delle stringhe

class Stringa {
	private:
		char *str;
	public:
        //Costruttore senza parametri
		Stringa ();
		//Costruttore con parametri
		Stringa ( const char * );
		//Distruttore
		~Stringa ();
		//Costruttore di copia
		Stringa(const Stringa&);
		
		//Metodi di gestione delle stringhe
		int compareTo ( Stringa );
		void concat ( Stringa );
		char charAt ( int );
		int indexOf ( Stringa );
		int lenght ();
		Stringa subStr ( int , int );
		void toLowerCase ();
        void toUpperCase ();
        void trim ();
		//Ridefinizione dell'operatore uguale
		Stringa& operator = ( Stringa );
		//Ridefinizione degli operatori stream
		friend istream& operator >> ( istream &, Stringa & );
		friend ostream& operator << ( ostream &, Stringa );
		//Ridefinizione operatori di confronto
		bool operator == ( Stringa );
		bool operator <= ( Stringa );
		bool operator >= ( Stringa );
		bool operator != ( Stringa );
		bool operator < ( Stringa );
		bool operator > ( Stringa );
};

Stringa :: Stringa () {
	str = NULL;
}

Stringa :: Stringa ( const char *s ) {
	str = new char[strlen(s)+1];
	strcpy ( str , s );
}

Stringa :: ~Stringa () {
	delete [] str;
}

Stringa :: Stringa (const Stringa& s) {
	str = new char[strlen(s.str)+1];
	strcpy(str,s.str);
}

int Stringa :: compareTo ( Stringa s ) {
    return strcmp(str,s.str);
}

void Stringa :: concat ( Stringa s ) {
	Stringa string;
	string.str = new char[strlen(str)+strlen(s.str)+1];
	int j=0;
	for(int i = 0; i < strlen(str); i++) {
		string.str[j]=str[i];
		j++;
	}
	for(int i = 0; i < strlen(s.str); i++) {
		string.str[j]=s.str[i];
		j++;
	}
	string.str[j]='\0';
	delete [] str;
	str = new char[strlen(str)+strlen(s.str)+1];
	strcpy(str,string.str);
}

char Stringa :: charAt ( int i ) {
	if(i<strlen(str)&&i>=0)
    	return str[i];
    return str[strlen(str)-1];
}

int Stringa :: indexOf ( Stringa s ) {
	bool st=false;
    if(strcmp(str,s.str)==0)
        return 0;
    if(strcmp(str,s.str)==1)
    	return -1;
    for(int i = 0; i < strlen(str); i++) {
        if(str[i]==s.str[0]) {
            for(int j = 0; j < strlen(s.str); j++) {
                if(str[i+j]!=s.str[j]){
                    st=false;
                    break;
				}
                if(strlen(s.str)-1==j)
                	st=true;
            }
		}
		if(st==true)
			return i;
    }
    return -1;
}

int Stringa :: lenght () {
      return strlen(str);
}

Stringa Stringa :: subStr (int start, int stop) {
    Stringa aux;
    if( (stop > start) && (start > 0) && (stop < strlen(str)) ) {
        aux.str = new char [stop-start+1];
        int j = 0;
        for(int i = start; i < stop+1; i++) {
            aux.str[j] = str[i];
            j++;
        }
        aux.str[j] = '\0';
    }
    return aux;
}
 
void Stringa :: toLowerCase () {
    for(int i = 0; i < strlen(str); i++) {
        if((str[i]>='A')&&(str[i]<='Z'))
            str[i]+=32;   
    }
}
   
void Stringa :: toUpperCase () {
    for(int i = 0; i < strlen(str); i++) {
        if((str[i]>='a')&&(str[i]<='z'))
            str[i]-=32;
    }
}
   
void Stringa :: trim () {
	int dim = strlen(str);
    for(int i = 0; i < dim; i++) {
        if(str[i]==' '||str[i]=='\t'||str[i]=='\n'){
			for(int j = i; j < dim; j++)
                str[j]=str[j+1];
            dim--;
            str[dim]='\0';
		}
    }
}


Stringa& Stringa :: operator = ( Stringa s2 ) {
	if(str!=NULL)
		delete [] str;
	str = new char[strlen(s2.str)+1];
	strcpy(str,s2.str);
}

istream& operator >> ( istream &in , Stringa &st ) {
	char aux[MAXDIM];
	fflush(stdin);
	gets (aux);
	delete [] st.str;
	st.str = new char[strlen(aux)+1];
	strcpy (st.str,aux);
}
	
ostream& operator << ( ostream &out , Stringa st ) {
	out << st.str;
}

bool Stringa :: operator == ( Stringa a ) {
    return (strcmp(a.str,str)==0);
}

bool Stringa :: operator <= ( Stringa a ) {
    return (strcmp(a.str,str)==1||strcmp(a.str,str)==0);
}

bool Stringa :: operator >= ( Stringa a ) {
    return (strcmp(a.str,str)==-1||strcmp(a.str,str)==0);
}

bool Stringa :: operator != ( Stringa a ) {
    return (strcmp(a.str,str)!=0);
}

bool Stringa :: operator < ( Stringa a ) {
    return (strcmp(a.str,str)==1);
}

bool Stringa :: operator > ( Stringa a ) {
    return (strcmp(a.str,str)==-1);
}
